# Property 1: In normal opertion (not in discard operation), write counter will
# 	      increment by 1 whenever writeB is deasserted. 

AG (IN_FIFO0.DISCARD = 0 * WRITEB = 0 * !(IN_FIFO0.CELLCOUNTER[5]=0 *
 					  IN_FIFO0.CELLCOUNTER[4]=1 *
 				          IN_FIFO0.CELLCOUNTER[3]=1 *
 				          IN_FIFO0.CELLCOUNTER[2]=0 *
 				          IN_FIFO0.CELLCOUNTER[1]=1 *
 					  IN_FIFO0.CELLCOUNTER[0]=1 )
 -> AX (IN_FIFO0.WR_PTR[6] == IN_FIFO0.wr_ptr_plus1[6] *
        IN_FIFO0.WR_PTR[0] == IN_FIFO0.wr_ptr_plus1[0]));
 
# Property 2:  Whenever ifrdb is deasserted, read counter will be incremented by 1 every clock 
#		cycle. 

AG (IN_FIFO0.IFRDB = 0 -> AX (IN_FIFO0.RD_PTR[6] == IN_FIFO0.rd_ptr_plus1[6] * 
                  	     IN_FIFO0.RD_PTR[0] == IN_FIFO0.rd_ptr_plus1[0]));

# Property 3: In a normal operation (not in cell discard operation), ifcounter will increment 
#	       by 1 whenever writeB is deasserted and ifrdb is asserted; and ifcounter will 
#	       decrement by 1 whenever writeB is asserted and ifrdb is deasserted.

AG (IN_FIFO0.DISCARD = 0 * WRITEB = 0 * IN_FIFO0.IFRDB = 1 -> 
			 AX (IN_FIFO0.IFCOUNTER[6] == IN_FIFO0.ifcounter_plus1[6] *
			    IN_FIFO0.IFCOUNTER[0] == IN_FIFO0.ifcounter_plus1[0]));
AG (IN_FIFO0.DISCARD = 0 * WRITEB = 1 * IN_FIFO0.IFRDB = 0 -> 
			 AX (IN_FIFO0.IFCOUNTER[6] == IN_FIFO0.ifcounter_minus1[6] * 
			     IN_FIFO0.IFCOUNTER[0] == IN_FIFO0.ifcounter_minus1[0] ));
# Property 7: If ipoll is low, the RCMP is transferring data from port 1 and port 2 has a cell to 
#	      send, the port 2 will be transmit a cell to RCMP next. 
AG (IN_FIFO0.IPOLL = 0 * IN_FIFO0.CELLCOUNTER[5] = 0 *
 			 IN_FIFO0.CELLCOUNTER[4] = 0 *
 			 IN_FIFO0.CELLCOUNTER[3] = 0 *
 			 IN_FIFO0.CELLCOUNTER[2] = 0 *
 			 IN_FIFO0.CELLCOUNTER[1] = 0 *
 			 IN_FIFO0.CELLCOUNTER[0] = 0 * 
 			 IN_FIFO0.p_state[1] = 0 *
 			 IN_FIFO0.p_state[0] = 1 *
 			 IN_FIFO0.ICA32[1] = 1  -> AX (IN_FIFO0.p_state[1] = 1 
 			                          * IN_FIFO0.p_state[0] = 0));
# Property 8: If ipoll is high, the RCMP is transferring data from the port of address 10 and port 
#             of address 11 has a cell to send, RCMP will transmit the cell from address 11 next.
AG (IN_FIFO0.IPOLL = 1 * IN_FIFO0.CELLCOUNTER[5] = 0 *
 			 IN_FIFO0.CELLCOUNTER[4] = 0 *
 			 IN_FIFO0.CELLCOUNTER[3] = 0 *
 			 IN_FIFO0.CELLCOUNTER[2] = 0 *
 			 IN_FIFO0.CELLCOUNTER[1] = 0 *
 			 IN_FIFO0.CELLCOUNTER[0] = 0 * 
 			 IN_FIFO0.IADDR[4] = 0 *
 			 IN_FIFO0.IADDR[3] = 1 * 
 			 IN_FIFO0.IADDR[2] = 0 * 
 			 IN_FIFO0.IADDR[1] = 1 *
 			 IN_FIFO0.IADDR[0] = 0 *
 			 IN_FIFO0.ICA1 = 0 -> AX (
 			 IN_FIFO0.IADDR[4] = 0 *
 			 IN_FIFO0.IADDR[3] = 1 * 
 			 IN_FIFO0.IADDR[2] = 0 * 
 			 IN_FIFO0.IADDR[1] = 1 *
 			 IN_FIFO0.IADDR[0] = 1)); 
 AG (IN_FIFO0.IPOLL = 1 * IN_FIFO0.CELLCOUNTER[5] = 0 *
 			 IN_FIFO0.CELLCOUNTER[4] = 0 *
 			 IN_FIFO0.CELLCOUNTER[3] = 0 *
 			 IN_FIFO0.CELLCOUNTER[2] = 0 *
 			 IN_FIFO0.CELLCOUNTER[1] = 0 *
 			 IN_FIFO0.CELLCOUNTER[0] = 0 * 
 			 IN_FIFO0.IADDR[4] = 0 *
 			 IN_FIFO0.IADDR[3] = 1 * 
 			 IN_FIFO0.IADDR[2] = 0 * 
 			 IN_FIFO0.IADDR[1] = 1 *
 			 IN_FIFO0.IADDR[0] = 1 *
 			 IN_FIFO0.ICA1 = 1 -> AX (
 			 IN_FIFO0.IADDR[4] = 0 *
 			 IN_FIFO0.IADDR[3] = 1 * 
 			 IN_FIFO0.IADDR[2] = 0 * 
 			 IN_FIFO0.IADDR[1] = 1 *
 			 IN_FIFO0.IADDR[0] = 1)); 